
;stampede amiga hints and tips
;july 1990

;hints and tips source. this source contains a simple
;introduction program which will runs on highsofts
;devpac ii

;just assemble the program using alt-a and then
;run it using alt-x

;dont be afraid to experiment with the code, you
;cant do any damage.


;first assign some equates to make the program
;easier to understand

;set tabs to 8

execbase	equ	4
openlibrary	equ	-408
openwindow	equ	-30
closewindow	equ	-36
readdata	equ	-42
writedata	equ	-48

;now the start of the main code

start	move.l	execbase,a6
	bsr	opendoslibrary
	bsr	opendoswindow
	bsr	text
	bsr	waitkey
	bsr	closedoswindow
	moveq	#0,d0
	rts			;return to devpac/cli


;before we can access any of the amigas window
;commands we must open what is called a library.
;this tells us where the routines for the dos are
;held in memory. this address may vary from amiga to amiga.

opendoslibrary
	lea	dosname,a1	;name of library
	jsr	openlibrary(a6)	;open the library
	move.l	d0,dosbase	;addrress in d0
	move.l	d0,a5		;save base in a5
	rts

;now we can open the window. this is done using
;the openwindow function in the doslibrary. the
;doslibrary is now accessed using a5. after
;opening the window, a handle is return in d0. this
;is used to identify the window for other windows.

opendoswindow
	move.l	#name,d1
	move.l	#1005,d2
	jsr	openwindow(a5)	;open the window
	move.l	d0,windowhandle
	rts

;the window is now displayed and the Amiga is using
;the current window. we can now output text to the
;window using the window handle.

text
	move.l	windowhandle,d1		;which window
	move.l	#messagetext,d2		;start of text
	move.l	#messagelength,d3	;length of text
	jsr	writedata(a5)		;output the data
	rts

;once the window has been initialised and the text
;display, we now wait for a key. this is done
;using the read function. "RAW" in the window data
;specifies that the Amiga will return one key at a time
;so we specify a length on 1

waitkey
	move.l	windowhandle,d1	;window identification
	move.l	#buffer,d2	;where to place data
	move.l	#1,d3		;length of data
	jsr	readdata(a5)	;read in the window
	rts

;now that the program has finished we must close
;the window before the quit. this stops the amiga
;from creating more and more windows. try removing
;the routine and see what happens.

closedoswindow
	move.l	windowhandle,d1	;the window to close
	jsr	closewindow(a5)	;close it
	rts

;after the program we have the data areas. these
;are accessed by the program using the label name.
;the last piece of data, the message text, has a special
;equate using the "*". this simply calculates the
;size of the message text in bytes.

windowhandle	dc.l	0
dosbase	dc.l	0		;address of library in memory
dosname	dc.b	"dos.library",0	;library name
name	dc.b	"RAW:0/0/640/100/STAMPEDE AMIGA",0
buffer	ds.b	1
messagetext
	dc.b	"STAMPEDE AMIGA Hints and Tips.",13,10
	dc.b	"DOS Window example",13,10
	dc.b	"Hit a key to quit..",0
messagelength	equ	*-messagetext
	even

